// build fish macro, reduces radius to the ends
#macro Build_Fish(a_points,r_stone)

 #local cnt=0;

 blob{threshold .9
  #while (cnt<dimension_size(a_points,1))
   #local tmp=a_points[cnt];
   sphere{tmp,(14-abs(tmp.x))/6,1}
   #local cnt=cnt+1;
  #end
 }

#end

#declare r_fish=seed(74);

// *** fish shape points ***
#declare a_points=array[19]
#declare a_points[0]=<-8,0,0>;
#declare a_points[1]=<-6,2,0>;
#declare a_points[2]=<-3,3,0>;
#declare a_points[3]=<0,3.25,0>;
#declare a_points[4]=<2,3,0>;
#declare a_points[5]=<6,2,0>;
#declare a_points[6]=<8,1.5,0>;
#declare a_points[7]=<10,2,0>;
#declare a_points[8]=<11,3,0>;
#declare a_points[9]=<10.5,1,0>;
#declare a_points[10]=<11,0,0>;
#declare a_points[11]=<12,-1.25,0>;
#declare a_points[12]=<10,-1,0>;
#declare a_points[13]=<8,-.5,0>;
#declare a_points[14]=<5,-1,0>;
#declare a_points[15]=<0,-2.5,0>;
#declare a_points[16]=<-3,-2.25,0>;
#declare a_points[17]=<-6,-2,0>;
#declare a_points[18]=<-8,-1,0>;

// *** fish shape triangles (vector elem. refers to point in a_points[]) ***
#declare a_triang=array[17]
#declare a_triang[0]=<1,18,19>;
#declare a_triang[1]=<1,2,18>;
#declare a_triang[2]=<2,3,18>;
#declare a_triang[3]=<3,17,18>;
#declare a_triang[4]=<3,16,17>;
#declare a_triang[5]=<3,4,16>;
#declare a_triang[6]=<4,5,16>;
#declare a_triang[7]=<5,15,16>;
#declare a_triang[8]=<5,6,15>;
#declare a_triang[9]=<6,14,15>;
#declare a_triang[10]=<6,7,14>;
#declare a_triang[11]=<7,13,14>;
#declare a_triang[12]=<7,8,13>;
#declare a_triang[13]=<8,10,13>;
#declare a_triang[14]=<8,9,10>;
#declare a_triang[15]=<10,11,13>;
#declare a_triang[16]=<11,12,13>;

// *** randomize and subdivide the fish shape ***
Subdivide_Array(a_points,a_triang,r_fish)
Subdivide_Array(a_points,a_triang,r_fish)
Subdivide_Array(a_points,a_triang,r_fish)
//Subdivide_Array(a_points,a_triang,r_fish)

#declare fish=
object{
 Build_Fish(a_points,r_fish)
 texture{
  pigment{Orange}
  normal{crackle scale 0.4}
  finish{F_MetalB}
 }
}
